/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Evaluation</DEPENDS>
    <DEPENDS>Controller</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
</DEPENDENCIES>
*/
CheckboxWidget.prototype             = new DomletCtr();
CheckboxWidget.prototype.constructor = CheckboxWidget;
CheckboxWidget.superclass            = DomletCtr.prototype;
function CheckboxWidget(sId, sWidgetDomId, sInactiveImgSrc, sHighlightImgSrc, sTippImgSrc, sCorrectImgSrc, oWorkItem)
{
  if (sId) { this.init(sId, sWidgetDomId, sInactiveImgSrc, sHighlightImgSrc, sTippImgSrc ,sCorrectImgSrc, oWorkItem); }
}
CheckboxWidget.prototype.init = function(sId, sWidgetDomId, sInactiveImgSrc, sHighlightImgSrc, sTippImgSrc, sCorrectImgSrc, oWorkItem)
{
  ;   
  this.sId = sId;
  this.sInactiveImgSrc = sInactiveImgSrc;
  this.sHighlightImgSrc = sHighlightImgSrc;
  this.sTippImgSrc = sTippImgSrc;
  this.sCorrectImgSrc = sCorrectImgSrc;
  this.modelItem = null;
  this.bOpposite = false;
  this.oWorkItem = oWorkItem;
  CheckboxWidget.superclass.init.call(this, this.sCheckboxWidgetDomId, this.sId, this);
  this.oWidget = document.getElementById(sWidgetDomId);
  this.sWidgetDomId = sWidgetDomId;
  if (this.oWidget == null)
  {
      ;
  }
  this.addDomlet(new Domlet(
    this.sWidgetDomId,      
    this.sWidgetDomId,      
    this,                        
  new Array('click' )))     
}
CheckboxWidget.prototype.getId = function()
{
  ////;
  return this.sId;
}
CheckboxWidget.prototype.start = function()
{
  ;
  var evaluation = this.modelItem;
  if ( ! evaluation )
  {
    ;
  }
  if ( this.bOpposite )
  {
    evaluation.start();
  }
  evaluation.registerStatusChangeListener(this);
}
CheckboxWidget.prototype.setModelItem = function(modelItem)
{
  ////;
  this.modelItem = modelItem;
}
CheckboxWidget.prototype.setEvaluation = function(oEvaluation, bOpposite)
{
  ;
  if ( !  bOpposite )
  {
    this.modelItem = oEvaluation;
  }
  else
  {
    this.modelItem = new Evaluation(oEvaluation.getId() + '_false', oEvaluation.getQuestion(), oEvaluation.getAnswer(), !oEvaluation.isCorrect(), !oEvaluation.isCorrect());
    this.oWorkItem.registerEvaluation(this.modelItem);
  }
  this.bOpposite = bOpposite;
}
CheckboxWidget.prototype.getModelItem = function()
{
  ////;
  return this.modelItem;
}
CheckboxWidget.prototype.setBroker = function(broker)
{
  ////;
  this.broker = broker;
}
CheckboxWidget.prototype.changed = function(model)
{  
  if (model.isCorrect())
  {
    ;
  }
  if (model.isEvaluated())
  {
    if (model.isCorrect())
    {
      if (model.isActive())
      {
        if (this.broker) { this.broker.showCorrect(); }
      }
      else
      {
        if (this.broker) { this.broker.showWrong(); }
        this.oWidget.src = this.sCorrectImgSrc;
      }
    }
    else
    {
    }
  }
  else
  {
    var nCount = model.countActiveEvaluations();
    if (nCount == 0)
    {
      switch (model.getEvaluation().getOrigin())
      {
        case 'system_solution':
          if (this.broker) { this.broker.showSolution(); }
          this.oWidget.src = this.sInactiveImgSrc;
          break;
        default:
          if (this.broker) { this.broker.showUnassigned(); }
          this.oWidget.src = this.sInactiveImgSrc;
          break;
      }
    }
    else
    {
      switch (model.getEvaluation().getOrigin())
      {
        case 'user':
          if (this.broker) { this.broker.showAssigned(); }
          this.oWidget.src = this.sHighlightImgSrc;
          break;
        case 'system_solution':
          if (this.broker) { this.broker.showSolution(); }
          this.oWidget.src = this.sTippImgSrc;
          break;
        case 'system_set':
          if (this.broker) { this.broker.showTipAssigned(); }
          this.oWidget.src = this.sTippImgSrc;
          break;
        case 'system_approve':
          if (this.broker) { this.broker.showTipApproveCorrect(); }
          this.oWidget.src = this.sHighlightImgSrc;
          break;
        case 'system_brand':
          if (this.broker) { this.broker.showTipBrandWrong(); }
          break;
      }
    }
  }
}
CheckboxWidget.prototype.eventFromChild = function(childName, eventType, event)
{
  ////;
  var domlet = this.domlets[childName];
  switch(eventType)
  {
    case "click" :
      //;      
      this.clickHandler(domlet, event);
      break;
  }
}
CheckboxWidget.prototype.clickHandler = function(domlet, event)
{
  ////;
  this.modelItem.setActive(true, 'user');  
}
