/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
function MultipleTrialsObserverAdapter(sId, nTrial)
{
  if (sId) this.init(sId, nTrial);
}
MultipleTrialsObserverAdapter.prototype.init = function(sId, nTrial)
{
  this.nTrial = nTrial;
  this.reachedAction = null;
}
MultipleTrialsObserverAdapter.prototype.getReachedTrialAction = function()
{
  return new ObjectMethodAction(this, "reachedTrial");
}
MultipleTrialsObserverAdapter.prototype.setReachedTrialAction = function(action)
{
  this.reachedAction = action;
}
MultipleTrialsObserverAdapter.prototype.reachedTrial = function(nTrial)
{
  if((nTrial == this.nTrial) && this.reachedAction)
  {
    this.reachedAction.invoke();
  }
}
