/*
<DEPENDENCIES>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
    <DEPENDS>Point</DEPENDS>
</DEPENDENCIES>
*/
DropDown.prototype             = new DomletCtr();
DropDown.prototype.constructor = DropDown;
DropDown.superclass            = DomletCtr.prototype;
var staticDropDown = new Array;
DropDown_getInstance = function(sId)
{
  var Instance = null;
  if ( staticDropDown[sId] )
  {
    Instance = staticDropDown[sId];
  }
  return Instance;
}
function DropDown(sId, sWidgetDomId, sWidgetDropControllerDomId,
                    sWidgetDisplayTextDomId,
                    sWidgetOptionContainerDomId,
                    sMenuOpenedPictureSrc,                     
                    sMenuClosedPictureSrc,                   
                    sFgColorTip, sFgColorWrong,
                    sFgColorCorrect, sFgColorNormal)
{
  if (sId) {
        this.init(sId, sWidgetDomId,
                        sWidgetDropControllerDomId,
                        sWidgetDisplayTextDomId,
                        sWidgetOptionContainerDomId,
                        sMenuOpenedPictureSrc, sMenuClosedPictureSrc,
                        sFgColorTip, sFgColorWrong,
                        sFgColorCorrect, sFgColorNormal);
  }
}
DropDown.prototype.init = function(sId, sWidgetDomId,
                    sWidgetDropControllerDomId,
                    sWidgetDisplayTextDomId,
                    sWidgetOptionContainerDomId,
                    sMenuOpenedPictureSrc,           
                    sMenuClosedPictureSrc,         
                    sFgColorTip,
                    sFgColorWrong,
                    sFgColorCorrect,
                    sFgColorNormal)
{
  ;
  this.sId = sId;
  this.modelItem = null;
  this.nTimeout = 500;
  this.timeoutId = null;
  this.sFgColorTip = null;
  this.sFgColorWrong = null;
  this.sFgColorNormal = null;
  this.imageTop = null;
  if(sFgColorTip)
  {
    this.sFgColorTip = sFgColorTip;
  }
  if(sFgColorWrong)
  {
      this.sFgColorWrong = sFgColorWrong;
  }
  if(sFgColorCorrect)
  {
      this.sFgColorCorrect = sFgColorCorrect;
  }
  if(sFgColorNormal)
  {
      this.sFgColorNormal = sFgColorNormal;
  }
  staticDropDown[sId] = this;
  DropDown.superclass.init.call(this, sWidgetDomId, sId, this);
  this.sMenuOpenedPictureSrc = sMenuOpenedPictureSrc;
  this.sMenuClosedPictureSrc = sMenuClosedPictureSrc;
  this.sWidgetDropControllerDomId = sWidgetDropControllerDomId;
  this.widget = document.getElementById(sWidgetDomId);
  this.sWidgetDomId = sWidgetDomId;
  if (this.widget == null)
  {
    ;
  }
  this.widgetDropController = document.getElementById(sWidgetDropControllerDomId);
    this.sWidgetDropControllerDomId = sWidgetDropControllerDomId;
    if (this.widgetDropController == null)
    {
      ;
  }
  this.widgetDisplayText = document.getElementById(sWidgetDisplayTextDomId);
    this.sWidgetDisplayTextDomId = sWidgetDisplayTextDomId;
    if (this.widgetDisplayText == null)
    {
      ;
  }
  this.widgetOptionContainer = document.getElementById(sWidgetOptionContainerDomId);
  this.sWidgetOptionContainerDomId = sWidgetOptionContainerDomId;
  if (this.widgetOptionContainer == null)
  {
    ;
  }
  this.addDomlet(new Domlet(
      this.sWidgetDomId,      
      this.sWidgetDomId,      
      this,                   
      new Array('click', 'mouseover', 'mouseout')) 
  )
  this.addDomlet(new Domlet(
    this.sWidgetDropControllerDomId,      
    this.sWidgetDropControllerDomId,      
    this,                   
    new Array()) 
  )
  this.addDomlet(new Domlet(
    this.sWidgetDisplayTextDomId,     
    this.sWidgetDisplayTextDomId,     
    this,                    
    new Array()) 
  )
  this.addDomlet(new Domlet(
    this.sWidgetOptionContainerDomId,     
    this.sWidgetOptionContainerDomId,     
    this,                    
    new Array('click', 'mouseover', 'mouseout')) 
  )
  this.widgetDisplayTextWidth = parseInt(this.widgetOptionContainer.offsetWidth)-2;
  Browser.changePixelStyle(this.widgetDisplayText, "width", this.widgetDisplayTextWidth);
}
DropDown.prototype.getWidthByDomNode = function(node)
{
  var actualwdith = 0;
  if (node.width)
  {
    actualwdith = node.width;
  }
  else
  {
    for (var m = node.firstChild; m!= null; m = m.nextSibling)
    {
      if (m.nodeType == 1 )
      {
        actualwdith += this.getWidthByDomNode(m);
      }
    }
  }
  return actualwdith;
}
DropDown.prototype.getWidthByDomID = function(sDomId)
{
  var actualwdith = 0;
  if (parseInt(Browser.getComputedStyleById(sDomId, 'width')))
  {
    actualwdith = parseInt(Browser.getComputedStyleById(sDomId, 'width'));
  }
  else
  {
    var node = Browser.getElementById(sDomId);
    for (child in node.childNodes)
    {
        actualwdith += this.getWidthByDomNode(child);
    }
  }
  return actualwdith;
}
DropDown.prototype.start = function()
{
  this.domlets[this.sWidgetOptionContainerDomId].setVisible(false);
  var point = new Point(0,0);
  Browser.getAbsPos(this.widget, point);
  var pointContainer = new Point(0,0);
  if('ie' == Browser.getId())
     pointContainer.y += parseInt(this.widgetDisplayText.offsetHeight)+2+ point.y;
  else
     pointContainer.y += parseInt(this.widgetDisplayText.offsetHeight)+ point.y;
  pointContainer.x = point.x;
  Browser.moveTo(this.widgetOptionContainer, pointContainer);
}
DropDown.prototype.getId = function()
{
  return this.sId;
}
DropDown.prototype.setModelItem = function(modelItem)
{
  ;
  this.modelItem = modelItem;
}
DropDown.prototype.getModelItem = function()
{
  return this.modelItem;
}
DropDown.prototype.setBroker = function(broker)
{
  ;
  this.broker = broker;
}
DropDown.prototype.changed = function(model)
{
  ;
  if (model.isEvaluated())
  {
    if (model.isSolved() == true)
    {
      if(this.sFgColorCorrect)
      {
        this.domlets[this.sWidgetDisplayTextDomId].setStyle('color',this.sFgColorCorrect);
      }
      if (this.broker) { this.broker.showCorrect(); }
    }
    else if (model.isSolved() == false)
    {
      if(this.sFgColorWrong)
      {
        this.domlets[this.sWidgetDisplayTextDomId].setStyle('color',this.sFgColorWrong);
      }
      if (this.broker) { this.broker.showWrong(); }
    }
    else
    {
    }
  }
  else
  {
    var nCount = model.countActiveEvaluations();
    if (nCount == 0)
    {
      switch (model.getEvaluation().getOrigin())
      {
        case 'system_solution':
          if(this.sFgColorTip)
          {
            this.domlets[this.sWidgetDisplayTextDomId].setStyle('color',this.sFgColorTip);
          }
          if (this.broker) { this.broker.showSolution(); }
          break;
        default:
          this.widgetDisplayText.value = '';
          if (this.broker) { this.broker.showUnassigned(); }
      }
    }
    else if (nCount == 1)
    {
      var aActiveEvaluations = model.getActiveEvaluations();
      switch (model.getEvaluation().getOrigin())
      {
        case 'user':
          if(this.sFgColorNormal)
          {
            this.domlets[this.sWidgetDisplayTextDomId].setStyle('color',this.sFgColorNormal);
          }
          this.widgetDisplayText.value = aActiveEvaluations[0].getAnswer().getText();
          if (this.broker) { this.broker.showAssigned(); }
          break;
        case 'system_solution':
          if(this.sFgColorTip)
          {
            this.domlets[this.sWidgetDisplayTextDomId].setStyle('color',this.sFgColorTip);
          }
          this.widgetDisplayText.value = aActiveEvaluations[0].getAnswer().getText();
          if (this.broker) { this.broker.showSolution(); }
          break;
        case 'system_set':
          if(this.sFgColorTip)
          {
            this.domlets[this.sWidgetDisplayTextDomId].setStyle('color',this.sFgColorTip);
          }
          this.widgetDisplayText.value = aActiveEvaluations[0].getAnswer().getText();
          if (this.broker) { this.broker.showTipAssigned(); }
          break;
        case 'system_approve':
          if(this.sFgColorTip)
          {
            this.domlets[this.sWidgetDisplayTextDomId].setStyle('color',this.sFgColorCorrect);
          }
          this.widgetDisplayText.value = aActiveEvaluations[0].getAnswer().getText();
          if (this.broker) { this.broker.showTipApproveCorrect(); }
          break;
        case 'system_brand':
          if(this.sFgColorWrong)
          {
            this.domlets[this.sWidgetDisplayTextDomId].setStyle('color',this.sFgColorWrong);
          }
          this.widgetDisplayText.value = aActiveEvaluations[0].getAnswer().getText();
          if (this.broker) { this.broker.showTipBrandWrong(); }
          break;
        }
    }
    else
    {
      ;
    }
  }
  if ( Browser.getId() == 'moz' )
  {
      this.showmenu(true, false);
   }
}
DropDown.prototype.eventFromChild = function(childName, eventType, event)
{
  //;
  var domlet = this.domlets[childName];
  switch(eventType)
  {
    case "click" :
      ;
      this.clickHandler(domlet, event);
      break;
    case "mouseover" :
      ;
      this.mouseoverHandler(domlet, event);
      break;
    case "mouseout" :
      ;
      this.mouseoutHandler(domlet, event);
      break;
  }
}
DropDown.prototype.clickHandler = function(domlet, event)
{
  ;
  if ( Browser.getId() == 'ie' )
  {
    Browser.eventStopPropagation(event);
    Browser.eventPreventDefault(event);
  }
  this.showmenu();
}
DropDown.prototype.mouseoverHandler = function(domlet, event)
{
  ;
  if ( this.timeoutId )
  {
    clearTimeout(this.timeoutId);
    this.timeoutId = null;
  }
}
DropDown.prototype.mouseoutHandler = function(domlet, event)
{
  ;
  if ( this.timeoutId )
  {
    clearTimeout(this.timeoutId);
  }
  this.timeoutId = window.setTimeout('DropDown_getInstance(\''+this.sId+'\').showmenu(true, false);', this.nTimeout);
}
DropDown.prototype.showmenu = function(bNotSwapMenu, bsetMenuOpen)
{
  ;
  if(bNotSwapMenu)
  {
    if(bsetMenuOpen)
    {
      this.domlets[this.sWidgetOptionContainerDomId].setVisible(true);
      this.domlets[this.sWidgetDropControllerDomId].setImageSource(this.sMenuOpenedPictureSrc);
      this.bDropDownMenuOpen = true;
    }
    else
    {
      this.domlets[this.sWidgetOptionContainerDomId].setVisible(false);
      this.domlets[this.sWidgetDropControllerDomId].setImageSource(this.sMenuClosedPictureSrc);
      this.bDropDownMenuOpen = false;
    }
  }
  else
  {
    if (this.bDropDownMenuOpen)
    {
      this.domlets[this.sWidgetOptionContainerDomId].setVisible(false);
      this.domlets[this.sWidgetDropControllerDomId].setImageSource(this.sMenuClosedPictureSrc);
      this.bDropDownMenuOpen = false;
    }
    else
    {
      this.domlets[this.sWidgetOptionContainerDomId].setVisible(true);
      this.domlets[this.sWidgetDropControllerDomId].setImageSource(this.sMenuOpenedPictureSrc);
      this.bDropDownMenuOpen = true;
    }
  }
}
DropDown.prototype.setFgColorTip = function(sFgColorTip)
{
  this.sFgColorTip = sFgColorTip;
}
DropDown.prototype.setFgColorWrong = function(sFgColorWrong)
{
  this.sFgColorWrong = sFgColorWrong;
}
DropDown.prototype.setFgColorCorrect = function(sFgColorCorrect)
{
  this.sFgColorCorrect = sFgColorCorrect;
}
DropDown.prototype.setFgColorNormal = function(sFgColorNormal)
{
  this.sFgColorNormal = sFgColorNormal;
}
DropDown.prototype.setImageTop = function(imageTop)
{
  this.imageTop = imageTop;
}
