/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Question</DEPENDS>
    <DEPENDS>Answer</DEPENDS>
    <DEPENDS>Evaluation</DEPENDS>
    <DEPENDS>QeaWorkItem</DEPENDS>
</DEPENDENCIES>
*/
FakeWorkItem.prototype             = new QeaWorkItem();
FakeWorkItem.prototype.constructor = FakeWorkItem;
FakeWorkItem.superclass            = QeaWorkItem.prototype;
function FakeWorkItem(sId) 
{
  if (sId) { this.init(sId); }
}
FakeWorkItem.prototype.init = function(sId)
{
  ;
  FakeWorkItem.superclass.init.call(this, sId);
  this.singleEvaluation = null;
  var question = new Question(this.sId + '_singleQuestion', 1);
  var answer = new Answer(this.sId + '_singleAnswer', 1);
  this.singleEvaluation = new Evaluation(this.sId + '_singleEvaluation', question, answer, true, true);
  this.registerQuestion(question);
  this.registerAnswer(answer);
  this.registerEvaluation(this.singleEvaluation);
}
FakeWorkItem.prototype.getSingleEvaluation = function()
{
  return this.singleEvaluation;
}
