/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
    <DEPENDS>Action</DEPENDS>
</DEPENDENCIES>
*/
LoginBroker.prototype             = new Broker();
LoginBroker.prototype.constructor = LoginBroker;
LoginBroker.superclass            = Broker.prototype;
function LoginBroker(sId)
{
  if (sId) { this.init(sId); }
}
LoginBroker.prototype.init = function(sId)
{
  ;
  this.sId = sId;
  this.ConversationController = null;
  LoginBroker.superclass.init.call(this, sId);
}
LoginBroker.prototype.setConversationController = function(ConversationController)
{
  this.ConversationController = ConversationController;
}
LoginBroker.prototype.doCancel = function()
{
  var paramArray = new Array();
  this.getMessage('cancel', paramArray);
}
LoginBroker.prototype.addCancelHandle = function(action)
{
  this.registerAction('cancel', action);
}
LoginBroker.prototype.getCancelAction = function()
{
  return new ObjectMethodAction(this, 'cancel');
}
LoginBroker.prototype.cancel = function()
{
  ;
  this.doCancel();
}
LoginBroker.prototype.doInvalidUser = function()
{
  var paramArray = new Array();
  this.getMessage('invalidUser', paramArray);
}
LoginBroker.prototype.addInvalidUserHandle = function(action)
{
  this.registerAction('invalidUser', action);
}
LoginBroker.prototype.getInvalidUserAction = function()
{
  return new ObjectMethodAction(this, 'invalidUser');
}
LoginBroker.prototype.invalidUser = function()
{
  ;
  this.doInvalidUser();
}
LoginBroker.prototype.doShowUsers = function()
{
  var paramArray = new Array();
  this.getMessage('showUsers', paramArray);
}
LoginBroker.prototype.addShowUsersHandle = function(action)
{
  this.registerAction('showUsers', action);
}
LoginBroker.prototype.getShowUsersAction = function()
{
  return new ObjectMethodAction(this, 'showUsers');
}
LoginBroker.prototype.showUsers = function()
{
  ;
  this.doShowUsers();
}
LoginBroker.prototype.doHideUsers = function()
{
  var paramArray = new Array();
  this.getMessage('hideUsers', paramArray);
}
LoginBroker.prototype.addHideUsersHandle = function(action)
{
  this.registerAction('hideUsers', action);
}
LoginBroker.prototype.getHideUsersAction = function()
{
  return new ObjectMethodAction(this, 'hideUsers');
}
LoginBroker.prototype.hideUsers = function()
{
  ;
  this.doHideUsers();
}
LoginBroker.prototype.doRegisterNewUser = function()
{
  var paramArray = new Array();
  this.getMessage('registerNewUser', paramArray);
}
LoginBroker.prototype.addRegisterNewUserHandle = function(action)
{
  this.registerAction('registerNewUser', action);
}
LoginBroker.prototype.getRegisterNewUserAction = function()
{
  return new ObjectMethodAction(this, 'registerNewUser');
}
LoginBroker.prototype.registerNewUser = function()
{
  ;
  this.doRegisterNewUser();
}
LoginBroker.prototype.addAfterRegisterNewUserHandle = function(action)
{
  this.registerAction('afterRegisterNewUser', action);
}
LoginBroker.prototype.doAfterRegisterNewUser = function()
{
  var paramArray = new Array();
  this.getMessage('afterRegisterNewUser', paramArray);
}
LoginBroker.prototype.getAfterRegisterNewUserAction = function()
{
  return new ObjectMethodAction(this, 'afterRegisterNewUser');
}
LoginBroker.prototype.afterRegisterNewUser = function()
{
  ;
  this.doAfterRegisterNewUser();
}
LoginBroker.prototype.doNoValidPassword = function()
{
  var paramArray = new Array();
  this.getMessage('noValidPassword', paramArray);
}
LoginBroker.prototype.addNoValidPasswordHandle = function(action)
{
  this.registerAction('noValidPassword', action);
}
LoginBroker.prototype.getNoValidPasswordAction = function()
{
  return new ObjectMethodAction(this, 'noValidPassword');
}
LoginBroker.prototype.noValidPassword = function()
{
  ;
  this.doNoValidPassword();
}
LoginBroker.prototype.doNoValidUsername = function()
{
  var paramArray = new Array();
  this.getMessage('noValidUsername', paramArray);
}
LoginBroker.prototype.addNoValidUsernameHandle = function(action)
{
  this.registerAction('noValidUsername', action);
}
LoginBroker.prototype.getNoValidUsernameAction = function()
{
  return new ObjectMethodAction(this, 'noValidUsername');
}
LoginBroker.prototype.noValidUsername = function()
{
  ;
  this.doNoValidUsername();
}
