/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
DateSelectionBroker.prototype = new Broker();
DateSelectionBroker.prototype.constructor = DateSelectionBroker;
DateSelectionBroker.superclass = Broker.prototype;
function DateSelectionBroker(sId)
{
	if (sId)
	{
		this.init(sId);
	}
}
DateSelectionBroker.prototype.init = function(sId)
{
	DateSelectionBroker.superclass.init.call(this, "DateSelectionBroker");
	this.sId = sId;
}
DateSelectionBroker.prototype.getId = function()
{
	return this.sId;
}
DateSelectionBroker.prototype.setManager = function(manager)
{
	this.manager = manager;
}
DateSelectionBroker.prototype.doFromDateChanged = function(date)
{
	var params = new Array();
	params.push(date);
	this.getMessage("fromchanged", params);
}
DateSelectionBroker.prototype.addFromDateChangedHandle = function(action)
{
	this.registerAction("fromchanged", action);
}
DateSelectionBroker.prototype.getChangeFromDateAction = function()
{
	return new ObjectMethodAction(this, "changeFromDate");
}
DateSelectionBroker.prototype.addChangeFromDateHandle = function(action)
{
	this.registerAction("changefrom", action);
}
DateSelectionBroker.prototype.changeFromDate = function(date)
{
	var params = new Array();
	params.push(date);
	this.getMessage("changefrom", params);
}
DateSelectionBroker.prototype.doToDateChanged = function(date)
{
	var params = new Array();
	params.push(date);
	this.getMessage("tochanged", params);
}
DateSelectionBroker.prototype.addToDateChangedHandle = function(action)
{
	this.registerAction("tochanged", action);
}
DateSelectionBroker.prototype.getChangeToDateAction = function()
{
	return new ObjectMethodAction(this, "changeToDate");
}
DateSelectionBroker.prototype.addChangeToDateHandle = function(action)
{
	this.registerAction("changeto", action);
}
DateSelectionBroker.prototype.changeToDate = function(date)
{
	var params = new Array();
	params.push(date);
	this.getMessage("changeto", params);
}
