/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
</DEPENDENCIES>
*/
DropDownSelectionOption.prototype = new DomletCtr();
DropDownSelectionOption.prototype.constructor = DropDownSelectionOption;
DropDownSelectionOption.superclass = DomletCtr.prototype;
function DropDownSelectionOption( sId, sWidgetDomId, sBgSelectedColor, sFgSelectedColor,
                                sBgHighlightColor, sFgHighlightColor )
{
  if( sId )
  {
    this.init(sId, sWidgetDomId, sBgSelectedColor, sFgSelectedColor, sBgHighlightColor, sFgHighlightColor);
  }
}
DropDownSelectionOption.prototype.init = function( sId, sWidgetDomId, sBgSelectedColor, sFgSelectedColor,
                                                 sBgHighlightColor, sFgHighlightColor )
{
  ;
  this.sBgSelectedColor = null;
  this.sFgSelectedColor = null;
  this.sBgHighlightColor = null;
  this.sFgHighlightColor = null;
  this.sFgTipColor = null;
  this.sFgNormalColor = null;
  this.sBgInactiveColor = null;
  this.sFgInactiveColor = null;
  this.sId = sId;
  this.modelItem = null;
  this.broker = null;
  this.widget = document.getElementById(sWidgetDomId);
  this.sWidgetDomId = sWidgetDomId;
  if( this.widget == null )
  {
    ;
  }
  this.sBgInactiveColor = Browser.getStyleById(this.sWidgetDomId, 'background');
  this.sFgInactiveColor = Browser.getStyleById(this.sWidgetDomId, 'color');
  if( !this.sBgInactiveColor )
  {
    this.sBgInactiveColor = '#FFFFFF';
  }
  if( !this.sFgInactiveColor )
  {
    this.sFgInactiveColor = '#000000';
  }
  if( sBgSelectedColor )
  {
    this.sBgSelectedColor = sBgSelectedColor;
  }
  if( sFgSelectedColor )
  {
    this.sFgSelectedColor = sFgSelectedColor;
  }
  if( sBgHighlightColor )
  {
    this.sBgHighlightColor = sBgHighlightColor;
  }
  if( sFgHighlightColor )
  {
    this.sFgHighlightColor = sFgHighlightColor;
  }
  DropDownSelectionOption.superclass.init.call(this, sWidgetDomId, sId, this);
  this.addDomlet(new Domlet(
          this.sWidgetDomId, 
          this.sWidgetDomId, 
          this, 
          new Array('click', 'mouseover', 'mouseout')) 
          )
}
DropDownSelectionOption.prototype.getId = function()
{
  return this.sId;
}
DropDownSelectionOption.prototype.setModelItem = function( modelItem )
{
  ;
  this.modelItem = modelItem;
}
DropDownSelectionOption.prototype.getModelItem = function()
{
  return this.modelItem;
}
DropDownSelectionOption.prototype.setBroker = function( broker )
{
  ;
  this.broker = broker;
}
DropDownSelectionOption.prototype.changed = function( model )
{
  ;
}
DropDownSelectionOption.prototype.eventFromChild = function( childName, eventType, event )
{
  //;
  var domlet = this.domlets[childName];
  switch( eventType )
  {
    case "click" :
      ;
      this.clickHandler(domlet, event);
      break;
    case "mouseover" :
      ;
      this.mouseoverHandler(domlet, event);
      break;
    case "mouseout" :
      ;
      this.mouseoutHandler(domlet, event);
      break;
  }
}
DropDownSelectionOption.prototype.setBgSelectedColor = function( sBgSelectedColor )
{
  this.sBgSelectedColor = sBgSelectedColor;
}
DropDownSelectionOption.prototype.setFgSelectedColor = function( sFgSelectedColor )
{
  this.sFgSelectedColor = sFgSelectedColor;
}
DropDownSelectionOption.prototype.setBgHighlightColor = function( sBgHighlightColor )
{
  this.sBgHighlightColor = sBgHighlightColor;
}
DropDownSelectionOption.prototype.setFgHighlightColor = function( sFgHighlightColor )
{
  this.sFgHighlightColor = sFgHighlightColor;
}
DropDownSelectionOption.prototype.setFgTipColor = function( sFgTipColor )
{
  this.sFgTipColor = sFgTipColor;
}
DropDownSelectionOption.prototype.setFgNormalColor = function( sFgNormalColor )
{
  this.sFgNormalColor = sFgNormalColor;
}
DropDownSelectionOption.prototype.clickHandler = function( domlet, event )
{
  ;
  if( this.modelItem.isActive() )
  {
    this.modelItem.setActive(false);
  }
  else
  {
    this.modelItem.setActive(true);
  }
  Browser.eventStopPropagation(event);
}
DropDownSelectionOption.prototype.mouseoverHandler = function( domlet, event )
{
  ;
  if( this.sBgHighlightColor )
  {
    this.domlets[this.sWidgetDomId].setStyle('background', this.sBgHighlightColor);
  }
  if( this.sFgHighlightColor )
  {
    this.domlets[this.sWidgetDomId].setStyle('color', this.sFgHighlightColor);
  }
}
DropDownSelectionOption.prototype.mouseoutHandler = function( domlet, event )
{
  if( ! this.modelItem.isActive() )
  {
    ;
    if( this.sBgHighlightColor )
    {
      this.domlets[this.sWidgetDomId].setStyle('background', this.sBgInactiveColor);
    }
    this.domlets[this.sWidgetDomId].setStyle('color', this.sFgInactiveColor);
    if( this.sFgNormalColor )
    {
      this.domlets[this.sWidgetDomId].setStyle('color', this.sFgNormalColor);
    }
  }
  else
  {
    ;
    if( this.sBgHighlightColor )
    {
      this.domlets[this.sWidgetDomId].setStyle('background', this.sBgSelectedColor);
    }
    if( this.sFgHighlightColor )
    {
      this.domlets[this.sWidgetDomId].setStyle('color', this.sFgSelectedColor);
    }
  }
}
