/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>ResultData</DEPENDS>
</DEPENDENCIES>
*/
function EvaluationEntry(cid, trace)
{
  	this.cid = cid;
  	this.trace = trace;
  	this.resultdata = null;
}
EvaluationEntry.prototype.getContentId= function() {
	return this.cid ;
}
EvaluationEntry.prototype.hasData= function() {
	return (this.resultdata);
}
EvaluationEntry.prototype.hasTraceData= function() {
	if (this.resultdata)
	{
		return this.resultdata.isTraceData();
	}
	else
		return false;
}
EvaluationEntry.prototype.hasTrackData= function() {
	return (this.resultdata);
}
EvaluationEntry.prototype.setData= function(resultdata) {
	this.resultdata = resultdata;
}
EvaluationEntry.prototype.getData= function() {
	return this.resultdata;
}
EvaluationEntry.prototype.isTrace= function() {
	return this.trace;
}
