/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>ServiceRegistryAccessor</DEPENDS>
</DEPENDENCIES>
*/
function RestartLocationStatic(sId, main, folderId, defaulturl, defaulttext, restarttext)
{
  if (sId) { this.init(sId, main, folderId, defaulturl, defaulttext, restarttext); }
}
RestartLocationStatic.prototype.init = function(sId, main, folderId, defaulturl, defaulttext, restarttext)
{
	this.sId = sId;
    this.initService();
    if (this.locationservice && this.locationservice.hasLastVistedLocation() && main == true)
    {
    	;
		this.url = this.locationservice.getLastVistedLocation();
   	 	this.text = restarttext;
    }
	else if (this.locationservice && this.locationservice.hasLastVistedLocationInFolder(folderId))
	{
		;
		this.url = this.locationservice.getLastVistedLocationInFolder(folderId);
   	 	this.text = restarttext;
	}
	else
    {
    	this.url = defaulturl;
   		this.text = defaulttext;
    }
}
RestartLocationStatic.prototype.setScreenBroker = function(broker)
{
	this.broker = broker;
}
RestartLocationStatic.prototype.getText = function()
{
	return this.text;
}
RestartLocationStatic.prototype.getStartLocationAction = function()
{
    return new ObjectMethodAction(this, 'restart');
}
RestartLocationStatic.prototype.restart = function()
{
	this.broker.getReplaceAction(this.url).invoke();
}
RestartLocationStatic.prototype.initService = function()
{
	var serviceregistry = ServiceRegistryAccess.getServiceRegistry();
	if (serviceregistry)
   		this.locationservice = serviceregistry.getService("locationservice");
}
