/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function HandleMap() {
    this.map = new Array();
    this.sendBuffer = new Array();
    this.sendBufferCounter = 0;
  	this.handleBuffer = new Array();
}
HandleMap.instance = new HandleMap();
HandleMap.prototype.setSender = function (sender) {
    this.sender = sender;
    if (this.handleBuffer.length > 0)
    {
    	
      	for ( var c = 0; c < this.handleBuffer.length; c++)
      	{
        	var handle =  this.handleBuffer[c];
        	this.sender.handleRegistered(handle);
      	}
    	this.handleBuffer = new Array();
    }
    for (var i = 0; i < this.sendBufferCounter; i++) {
        this.sendMessage(this.sendBuffer[i]["handle"],
                         this.sendBuffer[i]["methodName"],
                         this.sendBuffer[i]["args"]);
    }
}
HandleMap.prototype.flushSenderBuffer = function () {
    if(this.sender)
    {
        this.sender.flushBuffer();
    }
    else
    {
       ;
    }
}
HandleMap.prototype.registerSenderListener = function (handle)
{
	if (this.sender)
	{
		;
		
    	
    	this.sender.handleRegistered(handle);
	}
	else
	{
		;
		
		this.handleBuffer.push(handle);
	}
}
HandleMap.prototype.registerHandle = function (handleName, handle) {
    this.map[handleName] = handle;
}
HandleMap.prototype.sendMessage = function (handle, methodName, args) {
    ;
    ;
    if (this.sender == null) {
        this.sendBuffer[this.sendBufferCounter] = new Array();
        this.sendBuffer[this.sendBufferCounter]["handle"] = handle;
        this.sendBuffer[this.sendBufferCounter]["methodName"] = methodName;
        this.sendBuffer[this.sendBufferCounter]["args"] = args;
        this.sendBufferCounter++;
        return;
    }
    this.sender.send(handle, methodName, args);
    ;
}
HandleMap.prototype.getHandle = function (handleName) {
    return this.map[handleName];
}
