/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
    <DEPENDS>Action</DEPENDS>
</DEPENDENCIES>
*/
GlossarySearchBroker.prototype             = new Broker();
GlossarySearchBroker.prototype.constructor = GlossarySearchBroker;
GlossarySearchBroker.superclass            = Broker.prototype;
function GlossarySearchBroker(sId)
{
  if (sId) { this.init(sId); }
}
GlossarySearchBroker.prototype.init = function(sId)
{
  ;
  this.sId = sId;
  this.ConversationController = null;
  GlossarySearchBroker.superclass.init.call(this, sId);
}
GlossarySearchBroker.prototype.setConversationController = function(ConversationController)
{
  this.ConversationController = ConversationController;
}
GlossarySearchBroker.prototype.doPlaceOfFindingChanged = function(chars)
{
  var paramArray = new Array();
  paramArray[0] = chars;
  this.getMessage('placeOfFindingChanged', paramArray);
}
GlossarySearchBroker.prototype.addPlaceOfFindingChangedHandle = function(action)
{
  this.registerAction('placeOfFindingChanged', action);
}
GlossarySearchBroker.prototype.getPlaceOfFindingChangedAction = function()
{
  return new ObjectMethodAction(this, 'placeOfFindingChanged');
}
GlossarySearchBroker.prototype.placeOfFindingChanged = function(chars)
{
  ;
  this.doPlaceOfFindingChanged(chars);
}
