/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
RoleplayBroker.prototype             = new Broker();
RoleplayBroker.prototype.constructor = RoleplayBroker;
RoleplayBroker.superclass            = Broker.prototype;
function RoleplayBroker()
{
    ;
    this.conversationController = null;
     RoleplayBroker.superclass.init.call(this, "RoleplayBroker");
}
RoleplayBroker.prototype.setConversationController = function(conversationController)
{
    this.conversationController = conversationController;
}
RoleplayBroker.prototype.doRequestSoundPlay = function()
{
    this.getMessage("requestSoundPlay");
}
RoleplayBroker.prototype.addRequestSoundPlayHandle = function(action)
{
    this.registerAction("requestSoundPlay", action);
}
RoleplayBroker.prototype.getRequestSoundPlayAction = function(action)
{
    return new ObjectMethodAction(this, "requestSoundPlay");
}
RoleplayBroker.prototype.requestSoundPlay = function()
{
    if (this.conversationController)
        this.conversationController.shouldRequestSoundPlay();
    else
        this.doRequestSoundPlay();
}
RoleplayBroker.prototype.doRequestSoundStop = function()
{
    this.getMessage("requestSoundStop");
}
RoleplayBroker.prototype.addRequestSoundStopHandle = function(action)
{
    this.registerAction("requestSoundStop", action);
}
RoleplayBroker.prototype.getRequestSoundStopAction = function(action)
{
    return new ObjectMethodAction(this, "requestSoundStop");
}
RoleplayBroker.prototype.requestSoundStop = function()
{
    if (this.conversationController)
        this.conversationController.shouldRequestSoundStop();
    else
        this.doRequestSoundStop();
}
RoleplayBroker.prototype.doRequestSoundPause = function()
{
    this.getMessage("requestSoundPause");
}
RoleplayBroker.prototype.addRequestSoundPauseHandle = function(action)
{
    this.registerAction("requestSoundPause", action);
}
RoleplayBroker.prototype.getRequestSoundPauseAction = function(action)
{
    return new ObjectMethodAction(this, "requestSoundPause");
}
RoleplayBroker.prototype.requestSoundPause = function()
{
    if (this.conversationController)
        this.conversationController.shouldRequestSoundPause();
    else
        this.doRequestSoundPause();
}
RoleplayBroker.prototype.doRequestSoundRewind = function()
{
    this.getMessage("requestSoundRewind");
}
RoleplayBroker.prototype.addRequestSoundRewindHandle = function(action)
{
    this.registerAction("requestSoundRewind", action);
}
RoleplayBroker.prototype.getRequestSoundRewindAction = function(action)
{
    return new ObjectMethodAction(this, "requestSoundRewind");
}
RoleplayBroker.prototype.requestSoundRewind = function()
{
    if (this.conversationController)
        this.conversationController.shouldRequestSoundRewind();
    else
        this.doRequestSoundRewind();
}
RoleplayBroker.prototype.doRequestSoundForward = function()
{
    this.getMessage("requestSoundForward");
}
RoleplayBroker.prototype.addRequestSoundForwardHandle = function(action)
{
    this.registerAction("requestSoundForward", action);
}
RoleplayBroker.prototype.getRequestSoundForwardAction = function(action)
{
    return new ObjectMethodAction(this, "requestSoundForward");
}
RoleplayBroker.prototype.requestSoundForward = function()
{
    if (this.conversationController)
        this.conversationController.shouldRequestSoundForward();
    else
        this.doRequestSoundForward();
}
RoleplayBroker.prototype.doTimeLimitReached = function()
{
    this.getMessage("timeLimitReached");
}
RoleplayBroker.prototype.addTimeLimitReachedHandle = function(action)
{
    this.registerAction("timeLimitReached", action);
}
RoleplayBroker.prototype.getTimeLimitReachedAction = function(action)
{
    return new ObjectMethodAction(this, "timeLimitReached");
}
RoleplayBroker.prototype.timeLimitReached = function()
{
    if (this.conversationController)
        this.conversationController.shouldTimeLimitReached();
    else
        this.doTimeLimitReached();
}
RoleplayBroker.prototype.doRequestRecordMode = function()
{
    this.getMessage("requestRecordMode");
}
RoleplayBroker.prototype.addRequestRecordModeHandle = function(action)
{
    this.registerAction("requestRecordMode", action);
}
RoleplayBroker.prototype.getRequestRecordModeAction = function(action)
{
    return new ObjectMethodAction(this, "requestRecordMode");
}
RoleplayBroker.prototype.requestRecordMode = function()
{
    if (this.conversationController)
        this.conversationController.shouldRequestRecordMode();
    else
        this.doRequestRecordMode();
}
RoleplayBroker.prototype.doRequestRecord = function()
{
    this.getMessage("requestRecord");
}
RoleplayBroker.prototype.addRequestRecordHandle = function(action)
{
    this.registerAction("requestRecord", action);
}
RoleplayBroker.prototype.getRequestRecordAction = function(action)
{
    return new ObjectMethodAction(this, "requestRecord");
}
RoleplayBroker.prototype.requestRecord = function()
{
    if (this.conversationController)
        this.conversationController.shouldRequestRecord();
    else
        this.doRequestRecord();
}
RoleplayBroker.prototype.doRequestStopRecord = function()
{
    this.getMessage("requestStopRecord");
}
RoleplayBroker.prototype.addRequestStopRecordHandle = function(action)
{
    this.registerAction("requestStopRecord", action);
}
RoleplayBroker.prototype.getRequestStopRecordAction = function(action)
{
    return new ObjectMethodAction(this, "requestStopRecord");
}
RoleplayBroker.prototype.requestStopRecord = function()
{
    if (this.conversationController)
        this.conversationController.shouldRequestStopRecord();
    else
        this.doRequestStopRecord();
}
RoleplayBroker.prototype.doRequestContinue = function()
{
    this.getMessage("requestContinue");
}
RoleplayBroker.prototype.addRequestContinueHandle = function(action)
{
    this.registerAction("requestContinue", action);
}
RoleplayBroker.prototype.getRequestContinueAction = function(action)
{
    return new ObjectMethodAction(this, "requestContinue");
}
RoleplayBroker.prototype.requestContinue = function()
{
    if (this.conversationController)
        this.conversationController.shouldRequestContinue();
    else
        this.doRequestContinue();
}
RoleplayBroker.prototype.doRequestPlayAllPersonIntervals = function()
{
    this.getMessage("requestPlayAllPersonIntervals");
}
RoleplayBroker.prototype.addRequestPlayAllPersonIntervalsHandle = function(action)
{
    this.registerAction("requestPlayAllPersonIntervals", action);
}
RoleplayBroker.prototype.getRequestPlayAllPersonIntervalsAction = function(action)
{
    return new ObjectMethodAction(this, "requestPlayAllPersonIntervals");
}
RoleplayBroker.prototype.requestPlayAllPersonIntervals = function()
{
    if (this.conversationController)
        this.conversationController.shouldRequestPlayAllPersonIntervals();
    else
        this.doRequestPlayAllPersonIntervals();
}
RoleplayBroker.prototype.doRequestStopAllPersonIntervals = function()
{
    this.getMessage("requestStopAllPersonIntervals");
}
RoleplayBroker.prototype.addRequestStopAllPersonIntervalsHandle = function(action)
{
    this.registerAction("requestStopAllPersonIntervals", action);
}
RoleplayBroker.prototype.getRequestStopAllPersonIntervalsAction = function(action)
{
    return new ObjectMethodAction(this, "requestStopAllPersonIntervals");
}
RoleplayBroker.prototype.requestStopAllPersonIntervals = function()
{
    if (this.conversationController)
        this.conversationController.shouldRequestStopAllPersonIntervals();
    else
        this.doRequestStopAllPersonIntervals();
}
RoleplayBroker.prototype.doRequestStopOnePersonInterval = function()
{
    this.getMessage("requestStopOnePersonInterval");
}
RoleplayBroker.prototype.addRequestStopOnePersonIntervalHandle = function(action)
{
    this.registerAction("requestStopOnePersonInterval", action);
}
RoleplayBroker.prototype.getRequestStopOnePersonIntervalAction = function(action)
{
    return new ObjectMethodAction(this, "requestStopOnePersonInterval");
}
RoleplayBroker.prototype.requestStopOnePersonInterval = function()
{
    if (this.conversationController)
        this.conversationController.shouldRequestStopOnePersonInterval();
    else
        this.doRequestStopOnePersonInterval();
}
RoleplayBroker.prototype.doRequestPlayOnePersonInterval = function()
{
    this.getMessage("requestPlayOnePersonInterval");
}
RoleplayBroker.prototype.addRequestPlayOnePersonIntervalHandle = function(action)
{
    this.registerAction("requestPlayOnePersonInterval", action);
}
RoleplayBroker.prototype.getRequestPlayOnePersonIntervalAction = function(action)
{
    return new ObjectMethodAction(this, "requestPlayOnePersonInterval");
}
RoleplayBroker.prototype.requestPlayOnePersonInterval = function()
{
    if (this.conversationController)
        this.conversationController.shouldRequestPlayOnePersonInterval();
    else
        this.doRequestPlayOnePersonInterval();
}
RoleplayBroker.prototype.doEnableRecordMode = function()
{
    this.getMessage("enableRecordMode");
}
RoleplayBroker.prototype.addEnableRecordModeHandle = function(action)
{
    this.registerAction("enableRecordMode", action);
}
RoleplayBroker.prototype.getEnableRecordModeAction = function(action)
{
    return new ObjectMethodAction(this, "enableRecordMode");
}
RoleplayBroker.prototype.enableRecordMode = function()
{
    if (this.conversationController)
        this.conversationController.shouldEnableRecordMode();
    else
        this.doEnableRecordMode();
}
RoleplayBroker.prototype.doDisableRecordMode = function()
{
    this.getMessage("disableRecordMode");
}
RoleplayBroker.prototype.addDisableRecordModeHandle = function(action)
{
    this.registerAction("disableRecordMode", action);
}
RoleplayBroker.prototype.getDisableRecordModeAction = function(action)
{
    return new ObjectMethodAction(this, "disableRecordMode");
}
RoleplayBroker.prototype.disableRecordMode = function()
{
    if (this.conversationController)
        this.conversationController.shouldDisableRecordMode();
    else
        this.doDisableRecordMode();
}
RoleplayBroker.prototype.doCanRecord = function()
{
    this.getMessage("canRecord");
}
RoleplayBroker.prototype.addCanRecordHandle = function(action)
{
    this.registerAction("canRecord", action);
}
RoleplayBroker.prototype.getCanRecordAction = function(action)
{
    return new ObjectMethodAction(this, "canRecord");
}
RoleplayBroker.prototype.canRecord = function()
{
    if (this.conversationController)
        this.conversationController.shouldCanRecord();
    else
        this.doCanRecord();
}
RoleplayBroker.prototype.doCannotStopRecord = function()
{
    this.getMessage("cannotStopRecord");
}
RoleplayBroker.prototype.addCannotStopRecordHandle = function(action)
{
    this.registerAction("cannotStopRecord", action);
}
RoleplayBroker.prototype.getCannotStopRecordAction = function(action)
{
    return new ObjectMethodAction(this, "cannotStopRecord");
}
RoleplayBroker.prototype.cannotStopRecord = function()
{
    if (this.conversationController)
        this.conversationController.shouldCannotStopRecord();
    else
        this.doCannotStopRecord();
}
RoleplayBroker.prototype.doCanStopRecord = function()
{
    this.getMessage("canStopRecord");
}
RoleplayBroker.prototype.addCanStopRecordHandle = function(action)
{
    this.registerAction("canStopRecord", action);
}
RoleplayBroker.prototype.getCanStopRecordAction = function(action)
{
    return new ObjectMethodAction(this, "canStopRecord");
}
RoleplayBroker.prototype.canStopRecord = function()
{
    if (this.conversationController)
        this.conversationController.shouldCanStopRecord();
    else
        this.doCanStopRecord();
}
RoleplayBroker.prototype.doCannotRecord = function()
{
    this.getMessage("cannotRecord");
}
RoleplayBroker.prototype.addCannotRecordHandle = function(action)
{
    this.registerAction("cannotRecord", action);
}
RoleplayBroker.prototype.getCannotRecordAction = function(action)
{
    return new ObjectMethodAction(this, "cannotRecord");
}
RoleplayBroker.prototype.cannotRecord = function()
{
    if (this.conversationController)
        this.conversationController.shouldCannotRecord();
    else
        this.doCannotRecord();
}
RoleplayBroker.prototype.doStartedAllPersonIntervals = function()
{
    this.getMessage("startedAllPersonIntervals");
}
RoleplayBroker.prototype.addStartedAllPersonIntervalsHandle = function(action)
{
    this.registerAction("startedAllPersonIntervals", action);
}
RoleplayBroker.prototype.getStartedAllPersonIntervalsAction = function(action)
{
    return new ObjectMethodAction(this, "startedAllPersonIntervals");
}
RoleplayBroker.prototype.startedAllPersonIntervals = function()
{
    if (this.conversationController)
        this.conversationController.shouldStartedAllPersonIntervals();
    else
        this.doStartedAllPersonIntervals();
}
RoleplayBroker.prototype.doStoppedAllPersonIntervals = function()
{
    this.getMessage("stoppedAllPersonIntervals");
}
RoleplayBroker.prototype.addStoppedAllPersonIntervalsHandle = function(action)
{
    this.registerAction("stoppedAllPersonIntervals", action);
}
RoleplayBroker.prototype.getStoppedAllPersonIntervalsAction = function(action)
{
    return new ObjectMethodAction(this, "stoppedAllPersonIntervals");
}
RoleplayBroker.prototype.stoppedAllPersonIntervals = function()
{
    if (this.conversationController)
        this.conversationController.shouldStoppedAllPersonIntervals();
    else
        this.doStoppedAllPersonIntervals();
}
RoleplayBroker.prototype.doRequestForwardAllPersonIntervals = function()
{
    this.getMessage("requestForwardAllPersonIntervals");
}
RoleplayBroker.prototype.addRequestForwardAllPersonIntervalsHandle = function(action)
{
    this.registerAction("requestForwardAllPersonIntervals", action);
}
RoleplayBroker.prototype.getRequestForwardAllPersonIntervalsAction = function(action)
{
    return new ObjectMethodAction(this, "requestForwardAllPersonIntervals");
}
RoleplayBroker.prototype.requestForwardAllPersonIntervals = function()
{
    if (this.conversationController)
        this.conversationController.shouldRequestForwardAllPersonIntervals();
    else
        this.doRequestForwardAllPersonIntervals();
}
RoleplayBroker.prototype.doRequestRewindAllPersonIntervals = function()
{
    this.getMessage("requestRewindAllPersonIntervals");
}
RoleplayBroker.prototype.addRequestRewindAllPersonIntervalsHandle = function(action)
{
    this.registerAction("requestRewindAllPersonIntervals", action);
}
RoleplayBroker.prototype.getRequestRewindAllPersonIntervalsAction = function(action)
{
    return new ObjectMethodAction(this, "requestRewindAllPersonIntervals");
}
RoleplayBroker.prototype.requestRewindAllPersonIntervals = function()
{
    if (this.conversationController)
        this.conversationController.shouldRequestRewindAllPersonIntervals();
    else
        this.doRequestRewindAllPersonIntervals();
}
RoleplayBroker.prototype.doShowFeedback = function()
{
    this.getMessage("showFeedback");
}
RoleplayBroker.prototype.addShowFeedbackHandle = function(action)
{
    this.registerAction("showFeedback", action);
}
RoleplayBroker.prototype.getShowFeedbackAction = function(action)
{
    return new ObjectMethodAction(this, "showFeedback");
}
RoleplayBroker.prototype.showFeedback = function()
{
    if (this.conversationController)
        this.conversationController.shouldShowFeedback();
    else
        this.doShowFeedback();
}
RoleplayBroker.prototype.doHideFeedback = function()
{
    this.getMessage("hideFeedback");
}
RoleplayBroker.prototype.addHideFeedbackHandle = function(action)
{
    this.registerAction("hideFeedback", action);
}
RoleplayBroker.prototype.getHideFeedbackAction = function(action)
{
    return new ObjectMethodAction(this, "hideFeedback");
}
RoleplayBroker.prototype.hideFeedback = function()
{
    if (this.conversationController)
        this.conversationController.shouldHideFeedback();
    else
        this.doHideFeedback();
}
