/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function DropTargetWidgetSizeAdjuster(adjustmentManager)
{ 
  ;
  this.adjustmentManager = adjustmentManager;
  this.elements = new Array();
  this.adjustmentlistener = new Array();
  this.additionalPixels = 0;
  this.bStarted = false;
} 
DropTargetWidgetSizeAdjuster.prototype.addDropTargetElement = function(element)
{
    this.elements[this.elements.length] = element;
}
DropTargetWidgetSizeAdjuster.prototype.addAdjustmentListener = function(listener)
{
    this.adjustmentlistener[this.adjustmentlistener.length] = listener;
}
DropTargetWidgetSizeAdjuster.prototype.setAdjustmentManager = function(adjustmentManager)
{
    this.adjustmentManager = adjustmentManager;
}
DropTargetWidgetSizeAdjuster.prototype.start = function()
{
    ;
    if ( ! this.bStarted )
    {
      var maxSize = this.adjustmentManager.getMaxSize() + this.additionalPixels;
      ;
      for (var i = 0; i < this.elements.length; i++)
      {
          aktElement = this.elements[i];
          ;
          var dropWidget = aktElement.dropWidget;
          var ySize = dropWidget.offsetHeight;
          var sAreaDomId = aktElement.sAreaDomId;
          if (Browser.getComputedStyle(dropWidget ,'display')!= 'inline')
          {
              Browser.changePixelStyle(dropWidget, "width", maxSize);
              var eArea = Browser.getElementById(sAreaDomId);
               dropWidget.lastChild.nodeValue += '\u00a0';
          }
          else 
          {
              var xTempEl = document.createTextNode('\u00a0');
              dropWidget.appendChild(xTempEl);
              while (dropWidget.offsetWidth < maxSize)
              {
                  dropWidget.lastChild.nodeValue += '\u00a0';
              }
              var eArea = Browser.getElementById(sAreaDomId);
          }
          if (eArea.shape == 'poly' || eArea.shape == 'POLY')
          {
            var coords = new Array();
            coords = aktElement.eArea.coords.split(",");
            coords[2] = dropWidget.scrollWidth.toString();
            coords[4] = dropWidget.scrollWidth.toString();
            coords[5] = dropWidget.scrollHeight.toString();
            coords[7] = dropWidget.scrollHeight.toString();
            var test = coords.join();
            this.elements[i].eArea.coords = test;
          }
     }
     this.notifyAdjustmentListener();
     this.bStarted = true;
  }
}
DropTargetWidgetSizeAdjuster.prototype.notifyAdjustmentListener = function()
{
   for (var i = 0; i < this.adjustmentlistener.length; i++)
   {
      this.adjustmentlistener[i].adjust();
   }
}
DropTargetWidgetSizeAdjuster.prototype.setAdditionalPixels = function(pixels)
{
    this.additionalPixels = pixels;
}
