/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>QeaWorkItem</DEPENDS>
</DEPENDENCIES>
*/
MemoryWorkItem.prototype             = new QeaWorkItem();
MemoryWorkItem.prototype.constructor = MemoryWorkItem;
MemoryWorkItem.superclass            = QeaWorkItem.prototype;
function MemoryWorkItem(sId) 
{
  if (sId) { this.init(sId); }
}
MemoryWorkItem.prototype.init = function(sId)
{
  this.evaluateRequested = false;
  MemoryWorkItem.superclass.init.call(this, sId);
}
MemoryWorkItem.prototype.propagateStatus = function(evaluation)
{
  MemoryWorkItem.superclass.propagateStatus.call(this, evaluation);
  var excStatus = this.getExerciseStatus();
  if(!this.bEvaluated && !this.bStopped && !this.evaluateRequested)
  {
    if( evaluation && evaluation.isActive())
    {
      if (excStatus.nCorrect == excStatus.nCorrectStatus && excStatus.nWrongStatus == 0 && excStatus.sOrigin != 'system_set')
      {
        this.evaluateRequested = true;
        this.evaluate();
        this.evaluateRequested = false;
      }
    }
  }
}
