/*
 <DEPENDENCIES>
	 <DEPENDS>Logger</DEPENDS>
 </DEPENDENCIES>
 */
function StructureEntry(cid, url, adaptivesequence)
{
	this.cid = cid;
	this.url = url;
	this.adaptivesequence = adaptivesequence;
	this.children = new Array();
}
StructureEntry.prototype.getContentId = function()
{
	return this.cid;
}
StructureEntry.prototype.getURL = function()
{
	return this.url;
}
StructureEntry.prototype.isAdaptiveSequence = function()
{
	return this.adaptivesequence;
}
StructureEntry.prototype.addChild = function(structureEntry)
{
	this.children.push(structureEntry);
}
StructureEntry.prototype.getChildren = function()
{
	return this.children;
}
StructureEntry.prototype.hasChildren = function()
{
	return (this.children.length > 0);
}
StructureEntry.prototype.setParent = function(structureEntry)
{
	this.parent = structureEntry;
}
StructureEntry.prototype.getParent = function()
{
	return this.parent;
}
StructureEntry.prototype.setIndex = function(index)
{
	this.index = index;
}
StructureEntry.prototype.getIndex = function()
{
	return this.index;
}
